- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# TTMAC Class Reference

`#include <ttmac.h>`

Inheritance diagram for TTMAC:

List of all members.

## Detailed Description

Two-Track-MAC

160 Bit MAC with 160 Bit Key

Definition at line 34 of file ttmac.h.

## Public Types
typedef LittleEndian | ByteOrderClass
typedef word32 | HashWordType
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
Clonable * | Clone () const
| this is not implemented by most classes yet
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
size_t | MinKeyLength () const
| returns smallest valid key length in bytes */
size_t | MaxKeyLength () const
| returns largest valid key length in bytes */
size_t | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
size_t | GetValidKeyLength (size_t n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| returns the minimal requirement for secure IVs
unsigned int | IVSize () const
| returns size of IVs used by this object
unsigned int | DigestSize () const
| size of the hash returned by Final()
void | UncheckedSetKey (const byte *userKey, unsigned int keylength, const NameValuePairs &params)
void | TruncatedFinal (byte *mac, size_t size)
| truncated version of Final()
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
ByteOrder | GetByteOrder () const
unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
void | Update (const byte *input, size_t length)
| process more input
byte * | CreateUpdateSpace (size_t &size)
| request space to write input into
void | Restart ()
| discard the current state, and restart with a new message
HashTransformation & | Ref ()
| return a reference to this object,
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| truncated version of VerifyDigest()
virtual bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
static std::string __cdecl | StaticAlgorithmName ()
static size_t __cdecl | StaticGetValidKeyLength (size_t)
static void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
## Static Public Attributes
static const int | DIGESTSIZE = 20
static const int | KEYLENGTH
static const int | MIN_KEYLENGTH
static const int | MAX_KEYLENGTH
static const int | DEFAULT_KEYLENGTH
static const int | IV_REQUIREMENT
static const int | IV_LENGTH
static const int | BLOCKSIZE
static CompileAssert<((T_BlockSize &(T_BlockSize-1))==0)> | cryptopp_assert___LINE__
## Protected Member Functions
void | HashEndianCorrectedBlock (const word32 *data)
virtual void | HashEndianCorrectedBlock (const HashWordType *data)=0
void | Init ()
word32 * | StateBuf ()
word32 * | DataBuf ()
word32 | GetBitCountHi () const
word32 | GetBitCountLo () const
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
virtual size_t | HashMultipleBlocks (const word32 *input, size_t length)
void | HashBlock (const HashWordType *input)
void | ThrowIfInvalidTruncatedSize (size_t size) const
virtual const Algorithm & | GetAlgorithm () const=0
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
void | AssertValidKeyLength (size_t length) const
## Static Protected Member Functions
static void | Transform (word32 *digest, const word32 *X, bool last)
## Protected Attributes
FixedSizeSecBlock< word32, 10 > | m_digest
FixedSizeSecBlock< word32, 5 > | m_key
FixedSizeSecBlock< word32, T_BlockSize/sizeof(word32)> | m_data

## Member Enumeration Documentation

enum SimpleKeyingInterface::IV_Requirement`[inherited]`

Enumerator:

  UNIQUE_IV |
  RANDOM_IV |
  UNPREDICTABLE_RANDOM_IV |
  INTERNALLY_GENERATED_IV |
  NOT_RESYNCHRONIZABLE |

Definition at line 382 of file cryptlib.h.

## Member Function Documentation

HashTransformation& HashTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary HashTransformation object to a function that takes a non-const reference.

Definition at line 533 of file cryptlib.h.

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

compute hash for current message, then restart for a new message

Precondition:
  size of digest == DigestSize().

Definition at line 543 of file cryptlib.h.

Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), PKCS5_PBKDF2_HMAC< T >::DeriveKey(), DefaultEncryptor::FirstPut(), RandomPool::IncorporateEntropy(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

verify that digest is a valid digest for the current message, then reinitialize the object

Default implementation is to call Final() and do a bitwise comparison between its output and digest.

Definition at line 569 of file cryptlib.h.

Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[virtual, inherited]`

set or reset the key of this object

Parameters:

  | params | is used to specify Rounds, BlockSize, etc

Reimplemented in ECB_OneWay.

Definition at line 52 of file cryptlib.cpp.

References SimpleKeyingInterface::ThrowIfInvalidKeyLength().

Referenced by CBC_MAC< T >::CBC_MAC(), CipherModeFinalTemplate_CipherHolder< CIPHER, BASE >::CipherModeFinalTemplate_CipherHolder(), DMAC< T >::DMAC(), HMAC< T >::HMAC(), Weak::PanamaMAC< B >::PanamaMAC(), ECB_OneWay::SetKey(), SimpleKeyingInterface::SetKeyWithIV(), SimpleKeyingInterface::SetKeyWithRounds(), VMAC_Base::UncheckedSetKey(), and BlockOrientedCipherModeBase::UncheckedSetKey().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 388 of file cryptlib.h.

Referenced by SimpleKeyingInterface::ThrowIfInvalidIV(), SimpleKeyingInterface::ThrowIfResynchronizable(), and BlockOrientedCipherModeBase::UncheckedSetKey().

void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV |
| ) |  |  | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented in VMAC_Base.

Definition at line 96 of file cryptlib.cpp.

References RandomNumberGenerator::GenerateBlock(), and SimpleKeyingInterface::IVSize().

Referenced by VMAC_Base::GetNextIV().

The documentation for this class was generated from the following file:

- ttmac.h